# Template for Bug Issue

Please use this template if the issue that you are reporting is a (potential) bug in CV32E41P RTL, Documentation, Verification environment or Tool and Build system.

<br>**Note**: Please file bugs related to the core-v-verif verification environment in https://github.com/openhwgroup/core-v-verif instead.
<br>**Note**: Please file bugs related to the PULP tool chain in https://github.com/pulp-platform/pulp-riscv-gnu-toolchain instead.

## Bug Title
A clear and concise description of what the bug is.

### Component
Indicate the component in which you found a problem (and we will add the appropriate label):

**Component:RTL**: For issues in the RTL (e.g. for files in the rtl directory)
**Component:Doc **: For issues in the Documentation (e.g. for README.md and files in the doc directory)
**Component:Verif**: For issues in the verification environment or test cases (e.g. for behavioral code, testbench, C code, etc.)
**Component:Tool-and-build**: For issues in the tool and build flow (e.g. Makefile, FuseSoc, etc.)

### Steps to Reproduce
Please provide:
1. git hash
2. Command line
3. Logfile and/or wave-dump info (screen shots can be useful)
